100 rem Button Clock, V0.02, pjw, 2022 Oct 05
102
104 rem $$asmb=win1_uti_but_clk_ButClk_cde,0,10
106 rem $$chan=2
108 rem $$stak=256
110
112 ext_proc 'WINDSZ'
114 ext_fn 'BUTUSE%'
116
118 c$ = CMD$
120
122 rem $$off
124  rem For development. (SMSQ/E only in this form)
126  rem This bit is not included when program is compiled
128  if peek$(\\-4, 4) = 'SBAS' then
130   lrespr 'win1_uti_but_clk_ButClk_cde'
132   job_name 'Button Clock'
134  endif
136 rem $$on
138
140 sp_buthigh%     = 548: rem Button highlight
142 sp_butbd%       = 549: rem Button border
144 sp_butbg%       = 550: rem Button background
146 sp_butfg%       = 551: rem Button foreground
148
150 if len(c$) = 1 then
152  pal = (c$ instr '0123')
154  if pal: pal = pal - 1
156 else
158  pal = 0
160 endif
162
164 sp_jobpal -1, pal
166 ch% = fopen(#0; "con_")
168
170 x% = 44: y% = 14: xo% = x%: yo% = y%
172 ert butuse%(xo%, yo%)
174 xl% = xo% + x%: yl% = yo% + y%: rem Button limits
176
178 window#ch%; x%, y%, xo%, yo%
180 outl#ch%
182 wm_paper#ch%; sp_butbg%
184 wm_ink#ch%; sp_butfg%
186
188 wm_border#ch%; 1, sp_butbd%
190 windsz#ch%; x%! ly%, xo%, yo%
192 wm_border#ch%; 1, sp_buthigh%
194 windsz#ch%; x%! hy%, xo%, yo%
196 wm_border#ch%; 1, sp_butbd%
198 ly% = (ly% - 10) / 2
200 hy% = (hy% - 10) / 2
202
204 cls#ch%
206 spjob -1, 126: rem Set priority so clock will be picked with Button_Pick
208
210 rvin%  = 33
212 rvout% = 17
214 tio%   = 50
216 xp% = -1: yp% = -1
218 col    = 0
220
222 rem Assume we start with pointer outside button window
224
226 rep out_loop
228
230           ShowDate ly%
232
234           rdpt#ch%, rvin%, xp%, yp%, tio%
236
238           if xp% > xl% or xp% < xo%: next out_loop
240           if yp% > yl% or yp% < yo%: next out_loop
242
244 rem Pointer inside window now
246
248           wm_border#ch%; 1, sp_buthigh%
250
252           rep in_loop
254
256               ShowDate hy%
258
260               rdpt#ch%; rvout%, xp%, yp%, tio%
262               k% = (rvout% div 256)
264
266               sel on k%
268                = 27: exit out_loop
270                = 1, 2
272                  ex_m home_dir$ & 'CLK_obj'; '/P' & pal & ' /X' & (xo% - 12) & ' /Y' & (yo% + 16)
274               endsel
276
278               if xp% > xl% or xp% < xo%: exit in_loop
280               if yp% > yl% or yp% < yo%: exit in_loop
282
284              end rep in_loop
286
288 rem Pointer moved outside window now
290
292               wm_border#ch%; 1, sp_butbd%
294
296    endrep out_loop
298
300    quit
302
304 def proc ShowDate(y%)
306
308 d$ = date$
310 d$ = d$(13 to 17)
312 cursor#ch%; 4, y%
314 bput#ch%, d$
316
318 col = not col
320 if col: wm_ink#ch%; sp_butfg%: else: wm_ink#ch%; sp_butbg%
322 cursor#ch%; 16, y%: bput#ch%; ':'
324 wm_ink#ch%; sp_butfg%
326
328 enddef ShowDate
