100 rem $$asmb=win1_uti_but_clk_CLK_CDE,0,10
102 rem $$chan=3
104 rem $$stak=256
106 :
108 rem Clock
110 rem V0.01 2021 Apr 17
112 rem Based on POX - POpup eXternal - External Hint
114 :
116 rem ext_proc 'CLOCK'
118 ext_fn 'MN_CLK', 'RPT%'
120 :
122 rem $$off
124 if peek$(\\-4, 4) = "SBAS" then
126  lrespr 'win1_uti_but_clk_CLK_cde'
128  job_name 'CLK'
130 endif
132 rem $$on
134 :
136 quote$          = '"' & "'"
138 sp_hintbd%      = 552: rem Hint border
140 sp_hintbg%      = 553: rem Hint background
142 sp_hintfg%      = 554: rem Hint foreground
144 maxw%           = 508: rem max width
146 pal             =   0: rem Default palette
148 x% = -1: y% = x%
150 :
152 ert GetCmd(CMD$)
154 :
156 ch% = fopen(#0, "con_")
158 mdraw#ch%; mn_clk, x%, y%, 60, 20
160 rdpt#ch%; 48, x%, y%
162 wm_paper#ch%; sp_hintbg%: wm_ink#ch%; sp_hintfg%
164 CLOCK#ch%
166 tv% = 9: je% = 0: t% = 1
168 rep lp
170  susjb -1, t%
172  sw% = rpt%(#ch%; tv%, je%, x%, y%, t%)
174  if (tv% div 256) <> -1: exit lp
176 endrep lp
178 ptop#ch%; ojob(jobid): quit
180 :
182 :
184 rem + ------------------------------------------------------------------------ +
186 rem |<                         Command Line and Setup                         >|
188 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
190 rem | Command line parameters (all optional):                                  |
192 rem |                                                                          |
194 rem | /P - palette 0..3                                                        |
196 rem | /X - x-origen                                                            |
198 rem | /Y - y-origen                                                            |
200 rem |                                                                          |
202 rem | GLObal: quotes$, x%, y%                                                  |
204 rem | Dependencies: DETAB$                                                     |
206 rem + ------------------------------------------------------------------------ +
208 :
210 def fn GetCmd(cl$)
212 loc t, t$(200)
214 :
216 if len(cl$) = 0: ret 0
218 :
220 rem Get position
222 t$ = Getent$("X")
224 if len(t$): x% = t$
226 t$ = Getent$("Y")
228 if len(t$): y% = t$
230 :
232 rem Get palette
234 t$ = Getent$("P")
236 if t$ instr '0123': palette = t$: else: t$ = ''
238 if len(t$) = 0: palette = 0
240 sp_jobpal -1, palette: rem Use system palette
242 :
244 ret 0
246 enddef GetCmd
248 :
250 def fn Getent$(c$)
252 loc p%, t$(200)
254 rem Caller's cl$
256 rem Given the character get the entry
258 rem /C [<spaces>] ["|'] <entry> ["|'] <space> | / | <eol>
260 :
262 p% = '/' & c$ instr cl$
264 if p% = 0: ret ''
266 t$ = DETAB$(cl$(p% + 2 to len(cl$)))
268 p% = ' /' instr t$
270 if p% > 0: t$ = t$(1 to p%): else: p% = len(t$)
272 for p% = len(t$) to 1 step -1
274  if not t$(p%) instr ' /': exit p%
276 endfor p%
278 :
280 t$ = t$(1 to p%)
282 if len(t$) > 1 then
284  p% = t$(1) instr quote$
286  if p% then
288   if (t$(len(t$)) instr quote$) = p% then
290    t$ = t$(2 to len(t$) - 1)
292   endif: endif: endif
294 ret t$
296 enddef Getent$
298 :
300 :
